﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Data;
using Telerik.Windows.Controls;
using System.Linq.Expressions;

namespace ExpressionColumnSumFunction
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            Expression<Func<Player, int>> expression = x => x.Number * (int)x.Position;
            GridViewExpressionColumn column = this.playersGrid.Columns["RandomExpression"] as GridViewExpressionColumn;
            column.Expression = expression;
            column.AggregateFunctions.Add(new ExpressionSumFunction() { Caption = "Total: " });
        }
    }

    public class ExpressionSumFunction : AggregateFunction<Player, int>
    {
        public ExpressionSumFunction()
        {
            this.AggregationExpression = items => Sum(items);
        }

        private int Sum(IEnumerable<Player> source)
        {
            var result = 0;

            foreach (var item in source)
            {
                result += item.Number * (int)item.Position;
            }

            return result;
        }
    }
}
